Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-4_front_end-3_ooo_engine-2_execute_loop.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-4_front_end-3_ooo_engine-2_execute_loop.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-4_front_end-3_ooo_engine-2_execute_loop.cfg	(revision 88)
@@ -0,0 +1,98 @@
+Core_Glue
+4	4	+1	# nb_front_end                                                                                     
+1	1	+1	# nb_context                            [0]          [nb_front_end]
+2	2	+1	# nb_context                            [1]          [nb_front_end]
+4	4	+1	# nb_context                            [2]          [nb_front_end]
+3	3	+1	# nb_context                            [3]          [nb_front_end]
+3	3	+1	# nb_ooo_engine                                                                                    
+2	2	+1	# nb_execute_loop                                                                                  
+1	1	+1	# ooo_engine_nb_front_end               [0]          [nb_ooo_engine]
+2	2	+1	# ooo_engine_nb_front_end               [1]          [nb_ooo_engine]
+1	1	+1	# ooo_engine_nb_front_end               [2]          [nb_ooo_engine]
+1	1	+1	# ooo_engine_nb_execute_loop            [0]          [nb_ooo_engine]
+2	2	+1	# ooo_engine_nb_execute_loop            [1]          [nb_ooo_engine]
+1	1	+1	# ooo_engine_nb_execute_loop            [2]          [nb_ooo_engine]
+2	2	+1	# execute_loop_nb_ooo_engine            [0]          [nb_execute_loop]
+1	1	+1	# execute_loop_nb_ooo_engine            [1]          [nb_execute_loop]
+4	4	+1	# nb_inst_decod                         [0]          [nb_front_end]   
+2	2	+1	# nb_inst_decod                         [1]          [nb_front_end]   
+1	1	+1	# nb_inst_decod                         [2]          [nb_front_end]   
+3	3	+1	# nb_inst_decod                         [3]          [nb_front_end]   
+4	4 	+1	# front_end_nb_inst_branch_complete     [0]          [nb_front_end] 
+2	2 	+1	# front_end_nb_inst_branch_complete     [1]          [nb_front_end] 
+2	2 	+1	# front_end_nb_inst_branch_complete     [2]          [nb_front_end] 
+3	3 	+1	# front_end_nb_inst_branch_complete     [3]          [nb_front_end] 
+4	4	+1	# ooo_engine_nb_inst_branch_complete    [0]          [nb_ooo_engine]
+2	2	+1	# ooo_engine_nb_inst_branch_complete    [1]          [nb_ooo_engine]
+3	3	+1	# ooo_engine_nb_inst_branch_complete    [2]          [nb_ooo_engine]
+3	3	+1	# nb_inst_insert                        [0]          [nb_ooo_engine]  
+1	1	+1	# nb_inst_insert                        [1]          [nb_ooo_engine]  
+2	2	+1	# nb_inst_insert                        [2]          [nb_ooo_engine]  
+3	3	+1	# nb_inst_issue                         [0]          [nb_ooo_engine]  
+1	1	+1	# nb_inst_issue                         [1]          [nb_ooo_engine]  
+2	2	+1	# nb_inst_issue                         [2]          [nb_ooo_engine]  
+4	4	+1	# nb_inst_execute                       [0][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+3	3	+1	# nb_inst_execute                       [1][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+4	4	+1	# nb_inst_execute                       [1][1]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+4	4	+1	# nb_inst_execute                       [2][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+3	3	+1	# nb_read_unit                          [0]          [nb_execute_loop]
+3	3	+1	# nb_read_unit                          [1]          [nb_execute_loop]
+4	4	+1	# nb_write_unit                         [0]          [nb_execute_loop]
+3	3	+1	# nb_write_unit                         [1]          [nb_execute_loop]
+3	3	+1	# size_depth                                                                                       
+5	5	+1	# size_rob_ptr                                                                                     
+8	8	+1	# size_load_queue_ptr                                                                              
+8	8	+1	# size_store_queue_ptr                                                                             
+32	32	+1	# size_general_data                                                                                
+2	2	+1	# size_special_data                                                                                
+6	6	+1	# size_general_register                                                                            
+2	2	+1	# size_special_register                                                                            
+1	1	+1	# dispatch_priority                                                                                
+1	1	+1	# dispatch_load_balancing                                                                          
+1	1	+1	# table_dispatch                        [0][0][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][0][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][0][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][0][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][0][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][0][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][1][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [0][2][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [1][0][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][0][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][1][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][1][0][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][1][0][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][1][1][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+1	1	+1	# table_dispatch                        [2][1][1][1] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit]
+1	1	+1	# table_dispatch                        [2][1][1][2] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit]
+0	0	+1	# translate_ooo_engine_num_front_end    [0][0]       [nb_ooo_engine][ooo_engine_nb_front_end]
+1	1	+1	# translate_ooo_engine_num_front_end    [1][0]       [nb_ooo_engine][ooo_engine_nb_front_end]
+2	2	+1	# translate_ooo_engine_num_front_end    [1][1]       [nb_ooo_engine][ooo_engine_nb_front_end]
+3	3	+1	# translate_ooo_engine_num_front_end    [2][0]       [nb_ooo_engine][ooo_engine_nb_front_end]
+0	0	+1	# translate_ooo_engine_num_execute_loop [0][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+1	1	+1	# translate_ooo_engine_num_execute_loop [1][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+0	0	+1	# translate_ooo_engine_num_execute_loop [1][1]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+0	0	+1	# translate_ooo_engine_num_execute_loop [2][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+0	0	+1	# translate_execute_loop_num_ooo_engine [0][0]       [nb_execute_loop][execute_loop_nb_ooo_engine]
+2	2	+1	# translate_execute_loop_num_ooo_engine [0][1]       [nb_execute_loop][execute_loop_nb_ooo_engine]
+1	1	+1	# translate_execute_loop_num_ooo_engine [1][0]       [nb_execute_loop][execute_loop_nb_ooo_engine]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/config-min.cfg	(revision 88)
@@ -0,0 +1,30 @@
+Core_Glue
+1	1	+1	# nb_front_end                                                                                     
+1	1	+1	# nb_context                            [0]          [nb_front_end]
+1	1	+1	# nb_ooo_engine                                                                                    
+1	1	+1	# nb_execute_loop                                                                                  
+1	1	+1	# ooo_engine_nb_front_end               [0]          [nb_ooo_engine]
+1	1	+1	# ooo_engine_nb_execute_loop            [0]          [nb_ooo_engine]
+1	1	+1	# execute_loop_nb_ooo_engine            [0]          [nb_execute_loop]
+1	1	+1	# nb_inst_decod                         [0]          [nb_front_end]   
+1	1	+1	# front_end_nb_inst_branch_complete     [0]          [nb_front_end]   
+1	1	+1	# ooo_engine_nb_inst_branch_complete    [0]          [nb_ooo_engine]
+1	1	+1	# nb_inst_insert                        [0]          [nb_ooo_engine]  
+1	1	+1	# nb_inst_issue                         [0]          [nb_ooo_engine]  
+1	1	+1	# nb_inst_execute                       [0][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+1	1	+1	# nb_read_unit                          [0]          [nb_execute_loop]
+1	1	+1	# nb_write_unit                         [0]          [nb_execute_loop]
+1	1	+1	# size_depth                                                                                       
+1	1	+1	# size_rob_ptr                                                                                     
+1	1	+1	# size_load_queue_ptr                                                                              
+2	2	+1	# size_store_queue_ptr                                                                             
+32	32	+1	# size_general_data                                                                                
+2	2	+1	# size_special_data                                                                                
+6	6	+1	# size_general_register                                                                            
+2	2	+1	# size_special_register                                                                            
+1	1	+1	# dispatch_priority                                                                                
+1	1	+1	# dispatch_load_balancing                                                                          
+1	1	+1	# table_dispatch                        [0][0][0][0] [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] 
+0	0	+1	# translate_ooo_engine_num_front_end    [0][0]       [nb_ooo_engine][ooo_engine_nb_front_end]
+0	0	+1	# translate_ooo_engine_num_execute_loop [0][0]       [nb_ooo_engine][ooo_engine_nb_execute_loop]
+0	0	+1	# translate_execute_loop_num_ooo_engine [0][0]       [nb_execute_loop][execute_loop_nb_ooo_engine]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,29 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1024
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Core_Glue/include/Core_Glue.h"
+#include "Behavioural/include/Selftest.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+
+using namespace morpheo::behavioural::core::core_glue;
+
+void test    (string name,
+	      morpheo::behavioural::core::core_glue::Parameters * param);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,261 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Core_Glue/SelfTest/include/test.h"
+
+#define NB_PARAMS 13
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * nb_front_end                                                                                     (uint32_t         )\n"));
+  err (_(" * nb_context                            [nb_front_end]                                             (uint32_t         )\n"));
+  err (_(" * nb_ooo_engine                                                                                    (uint32_t         )\n"));
+  err (_(" * nb_execute_loop                                                                                  (uint32_t         )\n"));
+  err (_(" * ooo_engine_nb_front_end               [nb_ooo_engine]                                            (uint32_t         )\n"));
+  err (_(" * ooo_engine_nb_execute_loop            [nb_ooo_engine]                                            (uint32_t         )\n"));
+  err (_(" * execute_loop_nb_ooo_engine            [nb_execute_loop]                                          (uint32_t         )\n"));
+  err (_(" * nb_inst_decod                         [nb_front_end]                                             (uint32_t         )\n"));
+  err (_(" * front_end_nb_inst_branch_complete     [nb_front_end]                                             (uint32_t         )\n"));
+  err (_(" * ooo_engine_nb_inst_branch_complete    [nb_ooo_engine]                                            (uint32_t         )\n"));
+  err (_(" * nb_inst_insert                        [nb_ooo_engine]                                            (uint32_t         )\n"));
+  err (_(" * nb_inst_issue                         [nb_ooo_engine]                                            (uint32_t         )\n"));
+  err (_(" * nb_inst_execute                       [nb_ooo_engine][ooo_engine_nb_execute_loop]                (uint32_t         )\n"));
+  err (_(" * nb_read_unit                          [nb_execute_loop]                                          (uint32_t         )\n"));
+  err (_(" * nb_write_unit                         [nb_execute_loop]                                          (uint32_t         )\n"));
+  err (_(" * size_depth                                                                                       (uint32_t         )\n"));
+  err (_(" * size_rob_ptr                                                                                     (uint32_t         )\n"));
+  err (_(" * size_load_queue_ptr                                                                              (uint32_t         )\n"));
+  err (_(" * size_store_queue_ptr                                                                             (uint32_t         )\n"));
+  err (_(" * size_general_data                                                                                (uint32_t         )\n"));
+  err (_(" * size_special_data                                                                                (uint32_t         )\n"));
+  err (_(" * size_general_register                                                                            (uint32_t         )\n"));
+  err (_(" * size_special_register                                                                            (uint32_t         )\n"));
+  err (_(" * dispatch_priority                                                                                (Tpriority_t      )\n"));
+  err (_(" * dispatch_load_balancing                                                                          (Tload_balancing_t)\n"));
+  err (_(" * table_dispatch                        [nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit] (bool             )\n"));
+  err (_(" * translate_ooo_engine_num_front_end    [nb_ooo_engine][ooo_engine_nb_front_end]                   (uint32_t         )\n"));
+  err (_(" * translate_ooo_engine_num_execute_loop [nb_ooo_engine][ooo_engine_nb_execute_loop]                (uint32_t         )\n"));
+  err (_(" * translate_execute_loop_num_ooo_engine [nb_execute_loop][execute_loop_nb_ooo_engine]              (uint32_t         )\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  int nb_params;
+
+  nb_params =  static_cast<int> (2+NB_PARAMS);
+  if (argc < nb_params)
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  uint32_t                nb_front_end                         ;
+  uint32_t              * nb_context                           ;//[nb_front_end]
+  uint32_t                nb_ooo_engine                        ;
+  uint32_t                nb_execute_loop                      ;
+  uint32_t              * ooo_engine_nb_front_end              ;//[nb_ooo_engine]
+  uint32_t              * ooo_engine_nb_execute_loop           ;//[nb_ooo_engine]
+  uint32_t              * execute_loop_nb_ooo_engine           ;//[nb_execute_loop]
+  uint32_t              * nb_inst_decod                        ;//[nb_front_end] -> [sum_inst_decod]
+  uint32_t              * front_end_nb_inst_branch_complete    ;//[nb_front_end]
+  uint32_t              * ooo_engine_nb_inst_branch_complete   ;//[nb_ooo_engine]
+  uint32_t              * nb_inst_insert                       ;//[nb_ooo_engine]
+  uint32_t              * nb_inst_issue                        ;//[nb_ooo_engine]
+  uint32_t             ** nb_inst_execute                      ;//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+  uint32_t              * nb_read_unit                         ;//[nb_execute_loop]
+  uint32_t              * nb_write_unit                        ;//[nb_execute_loop]
+  uint32_t                size_depth                           ;
+  uint32_t                size_rob_ptr                         ;
+  uint32_t                size_load_queue_ptr                  ;
+  uint32_t                size_store_queue_ptr                 ;
+  uint32_t                size_general_data                    ;
+  uint32_t                size_special_data                    ;
+  uint32_t                size_general_register                ;
+  uint32_t                size_special_register                ;
+  Tpriority_t             dispatch_priority                    ;
+  Tload_balancing_t       dispatch_load_balancing              ;
+  bool               **** table_dispatch                       ;//[nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit]
+  uint32_t             ** translate_ooo_engine_num_front_end   ;//[nb_ooo_engine][ooo_engine_nb_front_end]
+  uint32_t             ** translate_ooo_engine_num_execute_loop;//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+  uint32_t             ** translate_execute_loop_num_ooo_engine;//[nb_execute_loop][execute_loop_nb_ooo_engine]
+
+  string name = argv[x++];
+
+  SELFTEST0(nb_front_end                         ,uint32_t         ,argv,x);
+
+  nb_params =  static_cast<int> (2+NB_PARAMS+
+                                 1*nb_front_end);
+  if (argc < nb_params)
+    usage (argc, argv);
+
+  SELFTEST1(nb_context                           ,uint32_t         ,argv,x,nb_front_end);
+  SELFTEST0(nb_ooo_engine                        ,uint32_t         ,argv,x);
+  SELFTEST0(nb_execute_loop                      ,uint32_t         ,argv,x);
+
+  nb_params = static_cast<int> (2+NB_PARAMS+
+                                3*nb_front_end+
+                                5*nb_ooo_engine+
+                                3*nb_execute_loop
+                                );
+  if (argc < nb_params)
+    usage (argc, argv);
+
+  SELFTEST1(ooo_engine_nb_front_end              ,uint32_t         ,argv,x,nb_ooo_engine);
+  SELFTEST1(ooo_engine_nb_execute_loop           ,uint32_t         ,argv,x,nb_ooo_engine);
+  SELFTEST1(execute_loop_nb_ooo_engine           ,uint32_t         ,argv,x,nb_execute_loop);
+  SELFTEST1(nb_inst_decod                        ,uint32_t         ,argv,x,nb_front_end);
+  SELFTEST1(front_end_nb_inst_branch_complete    ,uint32_t         ,argv,x,nb_front_end);
+  SELFTEST1(ooo_engine_nb_inst_branch_complete   ,uint32_t         ,argv,x,nb_ooo_engine);
+  SELFTEST1(nb_inst_insert                       ,uint32_t         ,argv,x,nb_ooo_engine);
+  SELFTEST1(nb_inst_issue                        ,uint32_t         ,argv,x,nb_ooo_engine);
+
+  uint32_t sum_ooo_engine_nb_front_end    = 0;
+  uint32_t sum_ooo_engine_nb_execute_loop = 0;
+  uint32_t sum_nb_inst_issue              = 0;
+
+  for (uint32_t i=0; i<nb_ooo_engine; ++i)
+    {
+      sum_ooo_engine_nb_front_end    += ooo_engine_nb_front_end    [i];
+      sum_ooo_engine_nb_execute_loop += ooo_engine_nb_execute_loop [i];
+      sum_nb_inst_issue              += nb_inst_issue              [i];
+    }
+
+  nb_params = static_cast<int> (2+NB_PARAMS+
+                                3*nb_front_end+
+                                5*nb_ooo_engine+
+                                3*nb_execute_loop+
+                                1*sum_ooo_engine_nb_execute_loop
+                                );
+  if (argc < nb_params)
+    usage (argc, argv);
+
+  SELFTEST2(nb_inst_execute                      ,uint32_t         ,argv,x,nb_ooo_engine,ooo_engine_nb_execute_loop[it1]);
+  SELFTEST1(nb_read_unit                         ,uint32_t         ,argv,x,nb_execute_loop);
+  SELFTEST1(nb_write_unit                        ,uint32_t         ,argv,x,nb_execute_loop);
+  SELFTEST0(size_depth                           ,uint32_t         ,argv,x);
+  SELFTEST0(size_rob_ptr                         ,uint32_t         ,argv,x);
+  SELFTEST0(size_load_queue_ptr                  ,uint32_t         ,argv,x);
+  SELFTEST0(size_store_queue_ptr                 ,uint32_t         ,argv,x);
+  SELFTEST0(size_general_data                    ,uint32_t         ,argv,x);
+  SELFTEST0(size_special_data                    ,uint32_t         ,argv,x);
+  SELFTEST0(size_general_register                ,uint32_t         ,argv,x);
+  SELFTEST0(size_special_register                ,uint32_t         ,argv,x);
+
+  uint32_t sum_execute_loop_nb_ooo_engine = 0;
+  uint32_t sum_nb_read_unit               = 0;
+
+  for (uint32_t i=0; i<nb_execute_loop; ++i)
+    {
+      sum_execute_loop_nb_ooo_engine += execute_loop_nb_ooo_engine [i];
+      sum_nb_read_unit               += nb_read_unit               [i];
+    }
+
+  nb_params = static_cast<int> (2+NB_PARAMS+
+                                3*nb_front_end+
+                                5*nb_ooo_engine+
+                                3*nb_execute_loop+
+                                sum_nb_inst_issue*sum_nb_read_unit+
+                                sum_ooo_engine_nb_front_end+
+                                2*sum_ooo_engine_nb_execute_loop+
+                                sum_execute_loop_nb_ooo_engine
+                                );
+  if (argc != nb_params)
+    usage (argc, argv);
+
+  SELFTEST0(dispatch_priority                    ,Tpriority_t      ,argv,x);
+  SELFTEST0(dispatch_load_balancing              ,Tload_balancing_t,argv,x);
+
+  SELFTEST4(table_dispatch                       ,bool             ,argv,x,nb_ooo_engine,nb_inst_issue[it1],nb_execute_loop,nb_read_unit[it3]);
+  SELFTEST2(translate_ooo_engine_num_front_end   ,uint32_t         ,argv,x,nb_ooo_engine,ooo_engine_nb_front_end[it1]);
+  SELFTEST2(translate_ooo_engine_num_execute_loop,uint32_t         ,argv,x,nb_ooo_engine,ooo_engine_nb_execute_loop[it1]);
+  SELFTEST2(translate_execute_loop_num_ooo_engine,uint32_t         ,argv,x,nb_execute_loop,execute_loop_nb_ooo_engine[it1]);
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      morpheo::behavioural::core::core_glue::Parameters * param = new morpheo::behavioural::core::core_glue::Parameters
+	(
+         nb_front_end                         ,
+         nb_context                           ,//[nb_front_end]
+         nb_ooo_engine                        ,
+         nb_execute_loop                      ,
+         ooo_engine_nb_front_end              ,//[nb_ooo_engine]
+         ooo_engine_nb_execute_loop           ,//[nb_ooo_engine]
+         execute_loop_nb_ooo_engine           ,//[nb_execute_loop]
+         nb_inst_decod                        ,//[nb_front_end]
+         front_end_nb_inst_branch_complete    ,//[nb_front_end]
+         ooo_engine_nb_inst_branch_complete   ,//[nb_ooo_engine]
+         nb_inst_insert                       ,//[nb_ooo_engine]
+         nb_inst_issue                        ,//[nb_ooo_engine]
+         nb_inst_execute                      ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+         nb_read_unit                         ,//[nb_execute_loop]
+         nb_write_unit                        ,//[nb_execute_loop]
+         size_depth                           ,
+         size_rob_ptr                         ,
+         size_load_queue_ptr                  ,
+         size_store_queue_ptr                 ,
+         size_general_data                    ,
+         size_special_data                    ,
+         size_general_register                ,
+         size_special_register                ,
+         dispatch_priority                    ,
+         dispatch_load_balancing              ,
+         table_dispatch                       ,//[nb_ooo_engine][nb_inst_issue][execute_loop][nb_read_unit]
+         translate_ooo_engine_num_front_end   ,//[nb_ooo_engine][ooo_engine_nb_front_end]
+         translate_ooo_engine_num_execute_loop,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+         translate_execute_loop_num_ooo_engine,//[nb_execute_loop][execute_loop_nb_ooo_engine]
+         true //is_toplevel
+        );
+      
+      msg(_("%s"),param->print(0).c_str());
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Core_Glue : no error");
+      else
+	TEST_KO("Core_Glue : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  DELETE2(translate_execute_loop_num_ooo_engine,nb_execute_loop,execute_loop_nb_ooo_engine[it1]);
+  DELETE2(translate_ooo_engine_num_execute_loop,nb_ooo_engine,ooo_engine_nb_execute_loop[it1]);
+  DELETE2(translate_ooo_engine_num_front_end   ,nb_ooo_engine,ooo_engine_nb_front_end[it1]);
+  DELETE4(table_dispatch                       ,nb_ooo_engine,nb_inst_issue[it1],nb_execute_loop,nb_read_unit[it2]);
+  DELETE1(nb_write_unit                        ,nb_execute_loop);
+  DELETE1(nb_read_unit                         ,nb_execute_loop);
+  DELETE2(nb_inst_execute                      ,nb_ooo_engine,ooo_engine_nb_execute_loop[it1]);
+  DELETE1(nb_inst_issue                        ,nb_ooo_engine);
+  DELETE1(ooo_engine_nb_inst_branch_complete   ,nb_ooo_engine);
+  DELETE1(front_end_nb_inst_branch_complete    ,nb_front_end);
+  DELETE1(nb_inst_decod                        ,nb_front_end);
+  DELETE1(execute_loop_nb_ooo_engine           ,nb_execute_loop);
+  DELETE1(ooo_engine_nb_execute_loop           ,nb_ooo_engine);
+  DELETE1(ooo_engine_nb_front_end              ,nb_ooo_engine);
+  DELETE1(nb_context                           ,nb_front_end);
+
+  return (_return);
+}
